
*regress ln1isqYaidratio_m1 RESCgov2_av4l##jhcs_cso_support_govt1  /*cso_govsupport1xgov4l*/ RESCavprcl2l lndd2_m1l lndistance colony lnimpexp2_m1l sc2 lnobssec34sum_pc_m1l /*lnsec_commdefl_2_m1l*/ year  d1-d22  if comCH10==1 & failtop20==0, cluster(ccode2) int2way , x(jhcs_cso_support_govt1) z(RESCgov2_av4l) zval(0/5) zlabel(Governance) xlabel(Govt CSO support) dvlabel(Change in M2)
*I have changed the int2way.do file to include the log option. I'm not sure if it works so I called it int2way2.do.

program define int2way3 
syntax , x(varname) z(varname)  zval(numlist) [notitle name(string) XLABel(string) ZLABel(string) DVLABel(string) xaxis LOG addplot(string)]
qui {
matrix V=e(V)
local dv `e(depvar)'
tempvar ZV star conb conse consb upper lower
gen `ZV' = .
local n = 1
foreach i of numlist `zval' {
replace `ZV' = `i' if _n==`n'
local ++n
}

forval k=1/3 {
 tempname b`k' v`k' 
 }
*nois macro dir
scalar `b1'=_b[`x'] /*bx*/
scalar `b2'=_b[`z'] /*bz*/
scalar `b3'=_b[`x'#`z'] /*bxz*/

scalar `v1'=_se[`x']^2 /*vx*/
scalar `v2'=_se[`z']^2 /*vz*/
scalar `v3'=_se[`x'#`z']^2 /*vxz*/

tempname covb1b3 covb2b3 
mat `covb1b3'=V["`x'","`x'#`z'"] /*covb1b3 */
mat `covb2b3'=V["`z'","`x'#`z'"]  /*covb2b3 */

gen `conb' = `b1'+`b3'*`ZV' if `ZV'~=.
gen `conse' = sqrt(`v1'+`v3'*(`ZV'^2) + 2*`ZV'*`covb1b3'[1,1]) if `ZV'~=.
gen `upper'=`conb'+1.96*`conse'
gen `lower'=`conb'-1.96*`conse'

gen `consb' = `conb'
replace `consb' = . if abs(`conb'/`conse')<1.96
 if "`log'"~="" {
replace `conb'=(exp(`conb')/(1+exp(`conb')))-.5 if `ZV'~=.
replace `consb'=(exp(`consb')/(1+exp(`consb')))-.5 if `ZV'~=.
replace `upper'=(exp(`upper')/(1+exp(`upper')))-.5 if `ZV'~=.
replace `lower'=(exp(`lower')/(1+exp(`lower')))-.5 if `ZV'~=.

}

 if "`xlabel'"=="" {
 local xlabel="`x'"
 }
 if "`zlabel'"=="" {
 local zlabel="`z'"
 }


if "`xaxis'"=="" {
local xaxis = ""
}
if "`xaxis'"~="" {
local xaxis ="xlab(`zval')"
}

if "`title'"=="" {
#delim ;
graph twoway  line `conb'  `ZV',  clpattern(solid )  clwidth(thin ...)  clcolor(black)
       || line `upper' `ZV' , clpattern(dash) clwidth(thin) clcolor(black) 
	   || line `lower' `ZV' , clpattern(dash) clwidth(thin) clcolor(black) ,
     
            yscale(noline)
            xscale(noline)
            yline(0, lcolor(black))  
            title("Marginal Effect of `xlabel' on `dvlabel'" "As `zlabel' changes", size(4))
                     xtitle(`zlabel', size(3)) `xaxis'
            ytitle(Marginal Effect of `xlabel', size(3))
            xsca(titlegap(2)) 
            ysca(titlegap(4)) name(`name')
			legend(label(1 "Marg Effect of `xlabel'") label(2 "95% CI") order(1 2))
            /*scheme(s2mono)*/ graphregion(fcolor(white))
            graphregion(margin(r=28))
		 ||  ,   `addplot'	;
#delim cr
}
if "`title'"~="" {
#delim ;
graph twoway  line `conb'  `ZV',  clpattern(solid )  clwidth(thin ...)  clcolor(black)
       || line `upper' `ZV' , clpattern(dash) clwidth(thin) clcolor(black) 
	   || line `lower' `ZV' , clpattern(dash) clwidth(thin) clcolor(black) 
      ||  ,   `addplot'
            yscale(noline)
            xscale(noline)
            yline(0, lcolor(black))  
      /*      title("Marginal Effect of `xlabel' on `dvlabel'" "As `z' changes", size(4)) */
                     xtitle(`z', size(3))  xlab(`zval')
  /*          ytitle(Marginal Effect of `xlabel', size(3)) */
            xsca(titlegap(2)) 
            ysca(titlegap(4)) name(`name')
/*			legend(label(1 "Marg Effect of `xlabel'") label(2 "95% CI") order(1 2)) */
legend(off) nodraw
           /* scheme(s2mono)*/ graphregion(fcolor(white))
            graphregion(margin(r=28));
#delim cr
}



}
end

